package qdbm;

class Curia {
	private var __c : Void;
	private var __p : String;

	private function new(c) {
		this.__c = c;
	}

	public static function open(path : String, writable : Bool, num : Int) : qdbm.Curia {
		var curia = new qdbm.Curia(curia_open(untyped path.__s, writable, num));
		return curia;
	}
	
	public static function remove(path : String) : Bool {
		return curia_remove(untyped path.__s);
	}

	public function close() : Bool {
		return curia_close(this.__c);
	}
	
	public function sync() : Bool {
		return curia_sync(this.__c);
	}

	public function optimize() : Bool {
		return curia_optimize(this.__c);
	}

	public function get(key : String) : String {
		var x = curia_get(this.__c, untyped key.__s, false);
		return if(x == null) null else new String(x);
	}

	public function out(key : String) : Bool {
		return curia_out(this.__c, untyped key.__s, false);
	}

	public function put(key : String, value : String) : Bool {
		return curia_put(this.__c, untyped key.__s, untyped value.__s, false);
	}


/*
	public function lget(key : String) : String {
		var x = curia_get(this.__c, untyped key.__s, true);
		return if(x == null) null else new String(x);
	}

	public function lout(key : String) : Bool {
		return curia_out(this.__c, untyped key.__s, true);
	}

	public function lput(key : String, value : String) : Bool {
		return curia_put(this.__c, untyped key.__s, untyped value.__s, true);
	}
*/


	public function hasNext() : Bool {
		return ( this.__p != null );
	}
 
	public function next() : String {
		var r = this.__p;
		var n = curia_next(this.__c);
		this.__p = if (n == null) null else new String(n);
		return r;
	}
	
	public function initIterator() : qdbm.Curia {
		curia_iterinit(this.__c);
		this.next();
		return this;
	}

	public function rnum() : Bool {
		return curia_rnum(this.__c);
	}
	
	
	static var curia_open = neko.Lib.load("qdbm","curia_open",3);
	static var curia_remove = neko.Lib.load("qdbm","curia_remove",1);
	static var curia_close = neko.Lib.load("qdbm","curia_close",1);
	static var curia_sync = neko.Lib.load("qdbm","curia_sync",1);
	static var curia_optimize = neko.Lib.load("qdbm","curia_optimize",1);
	static var curia_get = neko.Lib.load("qdbm","curia_get",3);
	static var curia_out = neko.Lib.load("qdbm","curia_out",3);
	static var curia_put = neko.Lib.load("qdbm","curia_put",4);
	static var curia_next = neko.Lib.load("qdbm","curia_next",1);
	static var curia_iterinit = neko.Lib.load("qdbm","curia_iterinit",1);
	static var curia_rnum = neko.Lib.load("qdbm","curia_rnum",1);

}

