package qdbm;

class Depot {
	private var __c : Void;
	private var __p : String;

	private function new(c) {
		this.__c = c;
	}

	public static function open(path : String, writable : Bool) : qdbm.Depot {
		var depot = new qdbm.Depot(depot_open(untyped path.__s, writable));
		return depot;
	}
	
	public static function remove(path : String) : Bool {
		return depot_remove(untyped path.__s);
	}

	public function close() : Bool {
		return depot_close(this.__c);
	}
	
	public function sync() : Bool {
		return depot_sync(this.__c);
	}

	public function optimize() : Bool {
		return depot_optimize(this.__c);
	}

	public function get(key : String) : String {
		var x = depot_get(this.__c, untyped key.__s);
		return if(x == null) null else new String(x);
	}

	public function out(key : String) : Bool {
		return depot_out(this.__c, untyped key.__s);
	}

	public function put(key : String, value : String) : Bool {
		return depot_put(this.__c, untyped key.__s, untyped value.__s);
	}

	public function hasNext() : Bool {
		return ( this.__p != null );
	}
 
	public function next() : String {
		var r = this.__p;
		var n = depot_next(this.__c);
		this.__p = if (n == null) null else new String(n);
		return r;
	}
	
	public function initIterator() : qdbm.Depot {
		depot_iterinit(this.__c);
		this.next();
		return this;
	}

	public function rnum() : Int {
		return depot_rnum(this.__c);
	}
 
	
	static var depot_open = neko.Lib.load("qdbm","depot_open",2);
	static var depot_remove = neko.Lib.load("qdbm","depot_remove",1);
	static var depot_close = neko.Lib.load("qdbm","depot_close",1);
	static var depot_sync = neko.Lib.load("qdbm","depot_sync",1);
	static var depot_optimize = neko.Lib.load("qdbm","depot_optimize",1);
	static var depot_get = neko.Lib.load("qdbm","depot_get",2);
	static var depot_out = neko.Lib.load("qdbm","depot_out",2);
	static var depot_put = neko.Lib.load("qdbm","depot_put",3);
	static var depot_next = neko.Lib.load("qdbm","depot_next",1);
	static var depot_iterinit = neko.Lib.load("qdbm","depot_iterinit",1);
	static var depot_rnum = neko.Lib.load("qdbm","depot_rnum",1);

}

